<template>
  <GI18nCard
    :i18n="i18n"
    :card="card"
    v-bind="$attrs"
    information-uri="https://dccwiki.ptb.de/en/dcccondition"
  >
    <v-row dense>
      <GCol cols="12">
        <div class="mt-4">
          <DccLocalizedTextBlock
            v-model="value.name"
            i18n="dcc.common.conditionType.name"
            validate="required"
          />
        </div>
      </GCol>
      <GCol cols="12" md="6">
        <GTextField
          v-model="value._attr.refType"
          i18n="dcc.common.attributes.refType"
          attr-ref-type
        />
      </GCol>
      <GCol cols="12" md="6">
        <DccSelect
          v-model="value.status"
          :items="states"
          i18n="dcc.common.conditionType.status"
          clearable
        />
      </GCol>
      <GCol cols="12">
        <RichContent
          v-if="value.description"
          v-model="value.description"
          class="mb-4"
          i18n="dcc.common.richContentType.description.title"
          optional
          level="second"
          @delete="deleteRichContent"
        />
        <Certificate
          v-if="value.certificate"
          v-model="value.certificate"
          class="mb-4"
          i18n="dcc.common.conditionType.certificate.title"
          optional
          @delete="deleteCertificate"
        />
        <QuantityList v-model="value.data" level="second" :card="true" />
      </GCol>
    </v-row>
  </GI18nCard>
</template>

<script>
import { HashType, RichContentType } from "@d-ptb/dcc-js";
import GI18nCard from "../../App/Common/GI18nCard";
import DccLocalizedTextBlock from "../../App/Form/XML/DccLocalizedTextBlock";
import RichContent from "~/components/DCC/Common/RichContent";
import Certificate from "~/components/DCC/Common/Certificate";
import DccSelect from "~/components/App/Form/XML/DccSelect";
import GTextField from "~/components/App/Form/gTextField";
import GCol from "~/components/App/Common/GCol";
import { insertIf } from "~/assets/util/general";

const states = [
  "beforeAdjustment",
  "afterAdjustment",
  "beforeRepair",
  "afterRepair",
];

export default {
  name: "Condition",
  components: {
    GCol,
    Certificate,
    DccSelect,
    DccLocalizedTextBlock,
    GI18nCard,
    // Needs to be imported asynchronously because of recursive components
    QuantityList: () => import("~/components/DCC/Common/QuantityList"),
    GTextField,
    RichContent,
  },
  props: {
    value: Object,
    updateAvailableElements: Function,
    card: {
      type: Boolean,
      default: true,
    },
    i18n: {
      type: String,
    },
  },
  computed: {
    states() {
      return states.map((x) => {
        return {
          key: x,
          text: this.$t(`dcc.common.conditionType.statusList.${x}`),
        };
      });
    },
    availableElements() {
      return ["richContentType", "hashType"]
        .filter((x) => !this.blacklist.includes(x))
        .map((x) => {
          return {
            text: this.$t(`dcc.common.${x}.title`),
            value: x,
            addElement: () => this.addElement(x),
          };
        });
    },
    blacklist() {
      return [
        ...insertIf(this.value.description, "richContentType"),
        ...insertIf(this.value.certificate, "hashType"),
      ];
    },
  },
  watch: {
    availableElements: {
      handler() {
        this.updateAvailableElements(this.availableElements);
      },
      immediate: true,
      deep: true,
    },
  },
  methods: {
    addElement(element) {
      switch (element) {
        case "richContentType":
          this.$set(this.value, "description", new RichContentType());
          break;
        case "hashType":
          this.$set(this.value, "certificate", new HashType());
          break;
      }
    },
    deleteCertificate() {
      confirm(this.$t("dcc.common.conditionType.certificate.confirmRemove")) &&
        this.$delete(this.value, "certificate");
    },
    deleteRichContent() {
      confirm(
        this.$t("dcc.common.richContentType.description.confirmRemove")
      ) && this.$delete(this.value, "description");
    },
  },
};
</script>
